import { PipelineTask } from './../pipeline-task.entity';
import { PipelineUnits } from '../enums/pipeline-units.enum';
import { Field, HideField, ObjectType } from '@nestjs/graphql';

@ObjectType()
export class PipelineTaskLogMessage {
  @HideField()
  task: PipelineTask;
  @Field(() => PipelineUnits, { nullable: true })
  unit?: PipelineUnits;
  @Field()
  time: Date;
  @Field()
  message: string;
  @Field()
  isError: boolean;

  static create(
    task: PipelineTask,
    unit: PipelineUnits,
    message: string,
    isError: boolean,
  ) {
    return Object.assign(new PipelineTaskLogMessage(), {
      task,
      message,
      time: new Date(),
      unit,
      isError,
    });
  }
}
